Index: branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/GeneralizedQuadraticAssignmentProblem.cs
===================================================================
--- branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/GeneralizedQuadraticAssignmentProblem.cs	(revision 7968)
+++ branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/GeneralizedQuadraticAssignmentProblem.cs	(revision 7970)
@@ -23,4 +23,5 @@
 using System.Drawing;
 using System.Linq;
+using HeuristicLab.Analysis.QualityAnalysis;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
@@ -31,5 +32,4 @@
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 using HeuristicLab.PluginInfrastructure;
-using HeuristicLab.Problems.GeneralizedQuadraticAssignment.Common;
 using HeuristicLab.Problems.Instances;
 
@@ -59,5 +59,4 @@
     public static readonly string CapacitiesDescription = "The capacities vector describes the available space at the locations.";
     public static readonly string TransportationCostsDescription = "The transportation cost represents the flow-unit per distance-unit cost factor. This value can also be set to 1 if these costs are factored into the weights matrix already.";
-    public static readonly string OverbookedCapacityPenaltyDescription = "The multiplier for the constraint violation when added to the quality.";
     public static readonly string BestKnownQualityDescription = "The best known quality (if available).";
     public static readonly string BestKnownSolutionDescription = "The best known solution (if available).";
@@ -65,4 +64,5 @@
     public static readonly string EquipmentNamesDescription = "Optional: A list of names that describes the equipments.";
     public static readonly string LocationNamesDescription = "Optional: A list of names that describes the locations.";
+    public static readonly string ExpectedRandomQualityDescription = "The expected quality value of a random solution.";
     #endregion
 
@@ -86,6 +86,6 @@
       get { return (FixedValueParameter<DoubleValue>)Parameters["TransportationCosts"]; }
     }
-    public FixedValueParameter<DoubleValue> OverbookedCapacityPenaltyParameter {
-      get { return (FixedValueParameter<DoubleValue>)Parameters["OverbookedCapacityPenalty"]; }
+    public FixedValueParameter<DoubleValue> ExpectedRandomQualityParameter {
+      get { return (FixedValueParameter<DoubleValue>)Parameters["ExpectedRandomQuality"]; }
     }
     public OptionalValueParameter<GQAPAssignment> BestKnownSolutionParameter {
@@ -124,11 +124,11 @@
       set { CapacitiesParameter.Value = value; }
     }
-    public DoubleValue TransportationCosts {
-      get { return TransportationCostsParameter.Value; }
-      set { TransportationCostsParameter.Value = value; }
-    }
-    public DoubleValue OverbookedCapacityPenalty {
-      get { return TransportationCostsParameter.Value; }
-      set { TransportationCostsParameter.Value = value; }
+    public double TransportationCosts {
+      get { return TransportationCostsParameter.Value.Value; }
+      set { TransportationCostsParameter.Value.Value = value; }
+    }
+    public double ExpectedRandomQuality {
+      get { return ExpectedRandomQualityParameter.Value.Value; }
+      set { ExpectedRandomQualityParameter.Value.Value = value; }
     }
     public StringArray EquipmentNames {
@@ -164,10 +164,10 @@
     }
     public GeneralizedQuadraticAssignmentProblem()
-      : base(new GQAPEvaluator(), new RandomSolutionCreator()) {
+      : base(new GQAPAdditivePenaltyEvaluator(), new RandomSolutionCreator()) {
       Parameters.Add(new ValueParameter<DoubleMatrix>("Weights", WeightsDescription, new DoubleMatrix(), false));
       Parameters.Add(new ValueParameter<DoubleMatrix>("Distances", DistancesDescription, new DoubleMatrix(), false));
       Parameters.Add(new ValueParameter<DoubleMatrix>("InstallationCosts", InstallationCostsDescription, new DoubleMatrix(), false));
       Parameters.Add(new FixedValueParameter<DoubleValue>("TransportationCosts", TransportationCostsDescription, new DoubleValue(1)));
-      Parameters.Add(new FixedValueParameter<DoubleValue>("OverbookedCapacityPenalty", OverbookedCapacityPenaltyDescription, new DoubleValue(100000)));
+      Parameters.Add(new FixedValueParameter<DoubleValue>("ExpectedRandomQuality", ExpectedRandomQualityDescription, new DoubleValue(0), true));
       Parameters.Add(new ValueParameter<DoubleArray>("Demands", DemandsDescription, new DoubleArray(), false));
       Parameters.Add(new ValueParameter<DoubleArray>("Capacities", CapacitiesDescription, new DoubleArray(), false));
@@ -310,5 +310,5 @@
     public void Load(DoubleArray demands, DoubleArray capacities,
       DoubleMatrix weights, DoubleMatrix distances, DoubleMatrix installationCosts,
-      DoubleValue transportationCosts, DoubleValue overbookedCapacityPenalty = null) {
+      DoubleValue transportationCosts) {
       if (weights == null || weights.Rows == 0)
         throw new System.IO.InvalidDataException(
@@ -316,6 +316,6 @@
       if (weights.Rows != weights.Columns)
         throw new System.IO.InvalidDataException(
-@"The weights matrix of the given instance contains an unequal number of rows
-and columns.");
+@"The weights matrix of the given instance contains
+an unequal number of rows and columns.");
       Weights = weights;
 
@@ -325,6 +325,6 @@
       if (distances.Rows != distances.Columns)
         throw new System.IO.InvalidDataException(
-@"The distances matrix of the given instance contains an unequal number of rows
-and columns.");
+@"The distances matrix of the given instance contains
+an unequal number of rows and columns.");
       Distances = distances;
 
@@ -335,6 +335,7 @@
         || installationCosts.Columns != distances.Columns)
         throw new System.IO.InvalidDataException(
-@"The installation costs matrix of the given instance contains different number
-of rows than given in the weights matrix and a different number of columns than
+@"The installation costs matrix of the given instance
+contains different number of rows than given in the
+weights matrix and a different number of columns than
 given in the distances matrix.");
       InstallationCosts = installationCosts;
@@ -345,6 +346,6 @@
       if (capacities.Length != distances.Rows)
         throw new System.IO.InvalidDataException(
-@"The given instance contains a different number of capacities than rows given in
-the distances matrix.");
+@"The given instance contains a different number of
+capacities than rows given in the distances matrix.");
       Capacities = capacities;
 
@@ -354,6 +355,6 @@
       if (demands.Length != weights.Rows)
         throw new System.IO.InvalidDataException(
-@"The given instance contains a different number of demands than rows given in
-the weights matrix.");
+@"The given instance contains a different number of
+demands than rows given in the weights matrix.");
       Demands = demands;
 
@@ -361,14 +362,40 @@
         throw new System.IO.InvalidDataException(
 @"The given instance does not contain transportation costs.");
-      TransportationCosts.Value = transportationCosts.Value;
-
-      if (overbookedCapacityPenalty != null)
-        OverbookedCapacityPenalty.Value = overbookedCapacityPenalty.Value;
+      TransportationCosts = transportationCosts.Value;
 
       BestKnownQuality = null;
       BestKnownSolution = null;
       BestKnownSolutions = null;
-    }
-
+      CalculateExpectedRandomQuality();
+    }
+
+    private void CalculateExpectedRandomQuality() {
+      if (IsConfigurationValid()) {
+        double[] avgDistances = new double[Capacities.Length];
+        for (int i = 0; i < Capacities.Length; i++) {
+          for (int j = 0; j < Capacities.Length; j++)
+            avgDistances[i] += Distances[i, j];
+          avgDistances[i] /= Capacities.Length;
+        }
+        double[] avgWeight = new double[Demands.Length];
+        for (int i = 0; i < Demands.Length; i++) {
+          for (int j = 0; j < Demands.Length; j++)
+            avgWeight[i] += Weights[i, j];
+          avgWeight[i] /= Demands.Length;
+        }
+        double avgCosts = InstallationCosts.Average();
+        double quality = 0;
+        for (int i = 0; i < Demands.Length; i++) {
+          double equipmentInfluence = 0;
+          for (int j = 0; j < Capacities.Length; j++)
+            equipmentInfluence += avgWeight[i] * avgDistances[j];
+          quality += equipmentInfluence * Demands.Length / (double)Capacities.Length;
+        }
+        quality *= TransportationCosts;
+        quality += avgCosts * Demands.Length;
+
+        ExpectedRandomQuality = quality;
+      }
+    }
     private void EvaluateAndLoadAssignment(int[] vector) {
       if (vector == null || vector.Length == 0) return;
@@ -382,13 +409,13 @@
       }
       double flowDistanceQuality, installationQuality, overbookedCapacity;
-      GQAPEvaluator.Evaluate(assignment, Weights, Distances, InstallationCosts, Demands, Capacities,
+      Evaluator.Evaluate(assignment, Weights, Distances, InstallationCosts, Demands, Capacities,
         out flowDistanceQuality, out installationQuality, out overbookedCapacity);
-      double quality = GQAPEvaluator.GetCombinedQuality(flowDistanceQuality, installationQuality, overbookedCapacity, TransportationCosts.Value, OverbookedCapacityPenalty.Value);
+      double quality = Evaluator.GetFitness(flowDistanceQuality, installationQuality, overbookedCapacity, TransportationCosts, ExpectedRandomQuality);
       BestKnownSolution = new GQAPAssignment((IntegerVector)assignment.Clone(), new DoubleValue(quality),
         new DoubleValue(flowDistanceQuality), new DoubleValue(installationQuality),
         new DoubleValue(overbookedCapacity), EquipmentNames, LocationNames, Distances, Weights, InstallationCosts,
-        Demands, Capacities, TransportationCosts, OverbookedCapacityPenalty);
+        Demands, Capacities, new DoubleValue(TransportationCosts), new DoubleValue(ExpectedRandomQuality), Evaluator);
       BestKnownQuality = new DoubleValue(quality);
-      BestKnownSolutions = new GQAPAssignmentArchive(EquipmentNames, LocationNames, Distances, Weights, InstallationCosts, Demands, Capacities, TransportationCosts, OverbookedCapacityPenalty);
+      BestKnownSolutions = new GQAPAssignmentArchive(EquipmentNames, LocationNames, Distances, Weights, InstallationCosts, Demands, Capacities, new DoubleValue(TransportationCosts), new DoubleValue(ExpectedRandomQuality), Evaluator);
       BestKnownSolutions.Solutions.Add(new GQAPSolution((IntegerVector)assignment.Clone(), new DoubleValue(quality), new DoubleValue(flowDistanceQuality), new DoubleValue(installationQuality), new DoubleValue(overbookedCapacity)));
     }
@@ -403,4 +430,5 @@
       base.OnEvaluatorChanged();
       Parameterize();
+      if (BestKnownSolution != null) EvaluateAndLoadAssignment(BestKnownSolution.Assignment);
       Evaluator.QualityParameter.ActualNameChanged += new System.EventHandler(Evaluator_QualityParameter_ActualNameChanged);
     }
@@ -436,4 +464,5 @@
       Operators.RemoveAll(x => x is ISingleObjectiveMoveEvaluator);
       Operators.AddRange(ApplicationManager.Manager.GetInstances<IGQAPMoveEvaluator>());
+      Operators.Add(new ScaledQualityDifferenceAnalyzer());
       Parameterize();
     }
@@ -445,38 +474,47 @@
       foreach (var op in operators.OfType<IAssignmentAwareGQAPOperator>()) {
         op.AssignmentParameter.ActualName = SolutionCreator.AssignmentParameter.ActualName;
-      }
-      foreach (var op in operators.OfType<IAssignmentsAwareGQAPOperator>()) {
-        op.AssignmentParameter.ActualName = SolutionCreator.AssignmentParameter.ActualName;
+        op.AssignmentParameter.Hidden = true;
       }
       foreach (var op in operators.OfType<IBestKnownQualityAwareGQAPOperator>()) {
         op.BestKnownQualityParameter.ActualName = BestKnownQualityParameter.Name;
+        op.BestKnownQualityParameter.Hidden = true;
       }
       foreach (var op in operators.OfType<IBestKnownSolutionAwareGQAPOperator>()) {
         op.BestKnownSolutionParameter.ActualName = BestKnownSolutionParameter.Name;
+        op.BestKnownSolutionParameter.Hidden = true;
       }
       foreach (var op in operators.OfType<IBestKnownSolutionsAwareGQAPOperator>()) {
         op.BestKnownSolutionsParameter.ActualName = BestKnownSolutionsParameter.Name;
+        op.BestKnownSolutionsParameter.Hidden = true;
       }
       foreach (var op in operators.OfType<ICapacitiesAwareGQAPOperator>()) {
         op.CapacitiesParameter.ActualName = CapacitiesParameter.Name;
+        op.CapacitiesParameter.Hidden = true;
       }
       foreach (var op in operators.OfType<IDemandsAwareGQAPOperator>()) {
         op.DemandsParameter.ActualName = DemandsParameter.Name;
+        op.DemandsParameter.Hidden = true;
       }
       foreach (var op in operators.OfType<IDistancesAwareGQAPOperator>()) {
         op.DistancesParameter.ActualName = DistancesParameter.Name;
+        op.DistancesParameter.Hidden = true;
       }
       foreach (var op in operators.OfType<IEquipmentNamesAwareGQAPOperator>()) {
         op.EquipmentNamesParameter.ActualName = EquipmentNamesParameter.Name;
+        op.EquipmentNamesParameter.Hidden = true;
       }
       foreach (var op in operators.OfType<IGQAPCrossover>()) {
         op.ParentsParameter.ActualName = SolutionCreator.AssignmentParameter.ActualName;
+        op.ParentsParameter.Hidden = true;
         op.ChildParameter.ActualName = SolutionCreator.AssignmentParameter.ActualName;
+        op.ChildParameter.Hidden = true;
       }
       foreach (var op in operators.OfType<IInstallationCostsAwareGQAPOperator>()) {
         op.InstallationCostsParameter.ActualName = InstallationCostsParameter.Name;
+        op.InstallationCostsParameter.Hidden = true;
       }
       foreach (var op in operators.OfType<ILocationNamesAwareGQAPOperator>()) {
         op.LocationNamesParameter.ActualName = LocationNamesParameter.Name;
+        op.LocationNamesParameter.Hidden = true;
       }
       var moveEvaluator = operators.OfType<IGQAPMoveEvaluator>().FirstOrDefault();
@@ -484,7 +522,11 @@
         if (moveEvaluator != null) {
           op.MoveQualityParameter.ActualName = moveEvaluator.MoveQualityParameter.ActualName;
+          op.MoveQualityParameter.Hidden = true;
           op.MoveFlowDistanceQualityParameter.ActualName = moveEvaluator.MoveFlowDistanceQualityParameter.ActualName;
+          op.MoveFlowDistanceQualityParameter.Hidden = true;
           op.MoveInstallationQualityParameter.ActualName = moveEvaluator.MoveInstallationQualityParameter.ActualName;
+          op.MoveInstallationQualityParameter.Hidden = true;
           op.MoveOverbookedCapacityParameter.ActualName = moveEvaluator.MoveOverbookedCapacityParameter.ActualName;
+          op.MoveOverbookedCapacityParameter.Hidden = true;
         }
       }
@@ -492,40 +534,74 @@
         if (moveEvaluator != null) {
           op.MoveQualityParameter.ActualName = moveEvaluator.MoveQualityParameter.ActualName;
+          op.MoveQualityParameter.Hidden = true;
           op.MoveFlowDistanceQualityParameter.ActualName = moveEvaluator.MoveFlowDistanceQualityParameter.ActualName;
+          op.MoveFlowDistanceQualityParameter.Hidden = true;
           op.MoveInstallationQualityParameter.ActualName = moveEvaluator.MoveInstallationQualityParameter.ActualName;
+          op.MoveInstallationQualityParameter.Hidden = true;
           op.MoveOverbookedCapacityParameter.ActualName = moveEvaluator.MoveOverbookedCapacityParameter.ActualName;
+          op.MoveOverbookedCapacityParameter.Hidden = true;
         }
         op.MaximizationParameter.ActualName = MaximizationParameter.Name;
-      }
-      foreach (var op in operators.OfType<IOverbookedCapacityPenaltyAwareGQAPOperator>()) {
-        op.OverbookedCapacityPenaltyParameter.ActualName = OverbookedCapacityPenaltyParameter.Name;
+        op.MaximizationParameter.Hidden = true;
+      }
+      foreach (var op in operators.OfType<IExpectedRandomQualityAwareGQAPOperator>()) {
+        op.ExpectedRandomQualityParameter.ActualName = ExpectedRandomQualityParameter.Name;
+        op.ExpectedRandomQualityParameter.Hidden = true;
       }
       foreach (var op in operators.OfType<IQualitiesAwareGQAPOperator>()) {
         op.QualityParameter.ActualName = Evaluator.QualityParameter.ActualName;
+        op.QualityParameter.Hidden = true;
         op.FlowDistanceQualityParameter.ActualName = Evaluator.FlowDistanceQualityParameter.ActualName;
+        op.FlowDistanceQualityParameter.Hidden = true;
         op.InstallationQualityParameter.ActualName = Evaluator.InstallationQualityParameter.ActualName;
+        op.InstallationQualityParameter.Hidden = true;
         op.OverbookedCapacityParameter.ActualName = Evaluator.OverbookedCapacityParameter.ActualName;
+        op.OverbookedCapacityParameter.Hidden = true;
         op.MaximizationParameter.ActualName = MaximizationParameter.Name;
+        op.MaximizationParameter.Hidden = true;
       }
       foreach (var op in operators.OfType<IQualityAwareGQAPOperator>()) {
         op.QualityParameter.ActualName = Evaluator.QualityParameter.ActualName;
+        op.QualityParameter.Hidden = true;
         op.FlowDistanceQualityParameter.ActualName = Evaluator.FlowDistanceQualityParameter.ActualName;
+        op.FlowDistanceQualityParameter.Hidden = true;
         op.InstallationQualityParameter.ActualName = Evaluator.InstallationQualityParameter.ActualName;
+        op.InstallationQualityParameter.Hidden = true;
         op.OverbookedCapacityParameter.ActualName = Evaluator.OverbookedCapacityParameter.ActualName;
+        op.OverbookedCapacityParameter.Hidden = true;
         op.MaximizationParameter.ActualName = MaximizationParameter.Name;
+        op.MaximizationParameter.Hidden = true;
       }
       foreach (var op in operators.OfType<ITransportationCostsAwareGQAPOperator>()) {
         op.TransportationCostsParameter.ActualName = TransportationCostsParameter.Name;
+        op.TransportationCostsParameter.Hidden = true;
       }
       foreach (var op in operators.OfType<IWeightsAwareGQAPOperator>()) {
         op.WeightsParameter.ActualName = WeightsParameter.Name;
+        op.WeightsParameter.Hidden = true;
+      }
+      foreach (var op in operators.OfType<IEvaluatorAwareGQAPOperator>()) {
+        op.EvaluatorParameter.ActualName = EvaluatorParameter.Name;
+        op.EvaluatorParameter.Hidden = true;
       }
 
       foreach (var op in operators.OfType<IIntegerVectorCrossover>()) {
         op.ParentsParameter.ActualName = SolutionCreator.AssignmentParameter.ActualName;
+        op.ParentsParameter.Hidden = true;
         op.ChildParameter.ActualName = SolutionCreator.AssignmentParameter.ActualName;
+        op.ChildParameter.Hidden = true;
       }
       foreach (var op in operators.OfType<IIntegerVectorManipulator>()) {
         op.IntegerVectorParameter.ActualName = SolutionCreator.AssignmentParameter.ActualName;
+        op.IntegerVectorParameter.Hidden = true;
+      }
+
+      foreach (var op in operators.OfType<ScaledQualityDifferenceAnalyzer>()) {
+        op.MinimumQualityParameter.ActualName = BestKnownQualityParameter.Name;
+        op.MinimumQualityParameter.Hidden = true;
+        op.MaximumQualityParameter.ActualName = ExpectedRandomQualityParameter.Name;
+        op.MaximumQualityParameter.Hidden = true;
+        op.QualityParameter.ActualName = "BestQuality";
+        op.QualityParameter.Hidden = true;
       }
     }
Index: branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/HeuristicLab.Problems.GeneralizedQuadraticAssignment-3.3.csproj
===================================================================
--- branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/HeuristicLab.Problems.GeneralizedQuadraticAssignment-3.3.csproj	(revision 7968)
+++ branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/HeuristicLab.Problems.GeneralizedQuadraticAssignment-3.3.csproj	(revision 7970)
@@ -105,6 +105,9 @@
     <Compile Include="Analyzers\GQAPPopulationDiversityAnalyzer.cs" />
     <Compile Include="Analyzers\GQAPSolutionArchiveAnalyzer.cs" />
+    <Compile Include="Evaluators\GQAPPenaltyLevelEvaluator.cs" />
+    <Compile Include="Evaluators\GQAPEvaluator.cs" />
     <Compile Include="Evaluators\GQAPNMoveEvaluator.cs" />
     <Compile Include="GQAPAssignment.cs" />
+    <Compile Include="Interfaces\IEvaluatorAwareGQAPOperator.cs" />
     <Compile Include="Operators\Crossovers\CordeauCrossover.cs" />
     <Compile Include="SolutionCreators\SlackMinimizationSolutionCreator.cs" />
@@ -115,5 +118,5 @@
     <Compile Include="SolutionCreators\RandomSolutionCreator.cs" />
     <None Include="Plugin.cs.frame" />
-    <Compile Include="Evaluators\GQAPEvaluator.cs" />
+    <Compile Include="Evaluators\GQAPAdditivePenaltyEvaluator.cs" />
     <Compile Include="GeneralizedQuadraticAssignmentProblem.cs" />
     <Compile Include="GQAPAssignmentArchive.cs" />
@@ -130,5 +133,5 @@
     <Compile Include="Interfaces\IGQAPEvaluator.cs" />
     <Compile Include="Interfaces\IQualityAwareGQAPOperator.cs" />
-    <Compile Include="Interfaces\IOverbookedCapacityPenaltyAwareGQAPOperator.cs" />
+    <Compile Include="Interfaces\IExpectedRandomQualityAwareGQAPOperator.cs" />
     <Compile Include="Interfaces\ITransportationCostsAwareGQAPOperator.cs" />
     <Compile Include="Interfaces\IInstallationCostsAwareGQAPOperator.cs" />
Index: branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Interfaces/IEvaluatorAwareGQAPOperator.cs
===================================================================
--- branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Interfaces/IEvaluatorAwareGQAPOperator.cs	(revision 7970)
+++ branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Interfaces/IEvaluatorAwareGQAPOperator.cs	(revision 7970)
@@ -0,0 +1,28 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Core;
+
+namespace HeuristicLab.Problems.GeneralizedQuadraticAssignment {
+  public interface IEvaluatorAwareGQAPOperator : IGQAPOperator {
+    IValueLookupParameter<IGQAPEvaluator> EvaluatorParameter { get; }
+  }
+}
Index: branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Interfaces/IExpectedRandomQualityAwareGQAPOperator.cs
===================================================================
--- branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Interfaces/IExpectedRandomQualityAwareGQAPOperator.cs	(revision 7970)
+++ branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Interfaces/IExpectedRandomQualityAwareGQAPOperator.cs	(revision 7970)
@@ -0,0 +1,29 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+
+namespace HeuristicLab.Problems.GeneralizedQuadraticAssignment {
+  public interface IExpectedRandomQualityAwareGQAPOperator : IGQAPOperator {
+    IValueLookupParameter<DoubleValue> ExpectedRandomQualityParameter { get; }
+  }
+}
Index: branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Interfaces/IGQAPEvaluator.cs
===================================================================
--- branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Interfaces/IGQAPEvaluator.cs	(revision 7968)
+++ branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Interfaces/IGQAPEvaluator.cs	(revision 7970)
@@ -22,4 +22,5 @@
 using HeuristicLab.Core;
 using HeuristicLab.Data;
+using HeuristicLab.Encodings.IntegerVectorEncoding;
 using HeuristicLab.Optimization;
 
@@ -30,4 +31,19 @@
     ILookupParameter<DoubleValue> InstallationQualityParameter { get; }
     ILookupParameter<DoubleValue> OverbookedCapacityParameter { get; }
+
+    double Evaluate(IntegerVector assignment, DoubleMatrix weights, DoubleMatrix distances,
+                    DoubleMatrix installCosts, DoubleArray demands, DoubleArray capacities,
+                    double transportationCosts, double expectedRandomQuality);
+
+    void Evaluate(IntegerVector assignment, DoubleMatrix weights, DoubleMatrix distances,
+                  DoubleMatrix installCosts, DoubleArray demands, DoubleArray capacities,
+                  out double flowDistanceQuality, out double installationQuality,
+                  out double overbookedCapacity);
+
+    double EvaluateOverbooking(DoubleArray slack, DoubleArray capacities);
+
+    double GetFitness(double flowDistanceQuality, double installationQuality,
+                      double overbookedCapacity, double transportationCosts,
+                      double expectedRandomQuality);
   }
 }
Index: branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Operators/Crossovers/CordeauCrossover.cs
===================================================================
--- branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Operators/Crossovers/CordeauCrossover.cs	(revision 7968)
+++ branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Operators/Crossovers/CordeauCrossover.cs	(revision 7970)
@@ -34,5 +34,5 @@
     IQualitiesAwareGQAPOperator, IWeightsAwareGQAPOperator, IDistancesAwareGQAPOperator, IInstallationCostsAwareGQAPOperator,
     IDemandsAwareGQAPOperator, ICapacitiesAwareGQAPOperator, ITransportationCostsAwareGQAPOperator,
-    IOverbookedCapacityPenaltyAwareGQAPOperator {
+    IExpectedRandomQualityAwareGQAPOperator {
 
     public ILookupParameter<BoolValue> MaximizationParameter {
@@ -69,6 +69,9 @@
       get { return (IValueLookupParameter<DoubleValue>)Parameters["TransportationCosts"]; }
     }
-    public IValueLookupParameter<DoubleValue> OverbookedCapacityPenaltyParameter {
-      get { return (IValueLookupParameter<DoubleValue>)Parameters["OverbookedCapacityPenalty"]; }
+    public IValueLookupParameter<DoubleValue> ExpectedRandomQualityParameter {
+      get { return (IValueLookupParameter<DoubleValue>)Parameters["ExpectedRandomQuality"]; }
+    }
+    public IValueLookupParameter<IGQAPEvaluator> EvaluatorParameter {
+      get { return (IValueLookupParameter<IGQAPEvaluator>)Parameters["Evaluator"]; }
     }
 
@@ -91,5 +94,6 @@
       Parameters.Add(new LookupParameter<DoubleArray>("Capacities", GeneralizedQuadraticAssignmentProblem.CapacitiesDescription));
       Parameters.Add(new ValueLookupParameter<DoubleValue>("TransportationCosts", GeneralizedQuadraticAssignmentProblem.TransportationCostsDescription));
-      Parameters.Add(new ValueLookupParameter<DoubleValue>("OverbookedCapacityPenalty", GeneralizedQuadraticAssignmentProblem.OverbookedCapacityPenaltyDescription));
+      Parameters.Add(new ValueLookupParameter<DoubleValue>("ExpectedRandomQuality", GeneralizedQuadraticAssignmentProblem.ExpectedRandomQualityDescription));
+      Parameters.Add(new ValueLookupParameter<IGQAPEvaluator>("Evaluator", "The evaluator used to evaluate solutions."));
     }
 
@@ -103,5 +107,5 @@
       DoubleMatrix weights, DoubleMatrix distances, DoubleMatrix installationCosts,
       DoubleArray demands, DoubleArray capacities,
-      DoubleValue transportationCosts, DoubleValue overbookedCapacityPenalty) {
+      double transportationCosts, double expectedRandomQuality, IGQAPEvaluator evaluator) {
       var mediana = Inizialize(distances);
       int m = capacities.Length;
@@ -158,5 +162,5 @@
         }
         if (!nofound) {
-          double sonQual = GQAPEvaluator.Evaluate(son, weights, distances, installationCosts, demands, capacities, transportationCosts, overbookedCapacityPenalty);
+          double sonQual = evaluator.Evaluate(son, weights, distances, installationCosts, demands, capacities, transportationCosts, expectedRandomQuality);
           if (sonQual < fbest) {
             fbest = sonQual;
@@ -197,5 +201,5 @@
           onefound = true;
         } else {
-          double sonQual = GQAPEvaluator.Evaluate(son, weights, distances, installationCosts, demands, capacities, transportationCosts, overbookedCapacityPenalty);
+          double sonQual = evaluator.Evaluate(son, weights, distances, installationCosts, demands, capacities, transportationCosts, expectedRandomQuality);
           if (sonQual < fbest) {
             fbest = sonQual;
@@ -227,5 +231,6 @@
         WeightsParameter.ActualValue, DistancesParameter.ActualValue, InstallationCostsParameter.ActualValue,
         DemandsParameter.ActualValue, CapacitiesParameter.ActualValue,
-        TransportationCostsParameter.ActualValue, OverbookedCapacityPenaltyParameter.ActualValue);
+        TransportationCostsParameter.ActualValue.Value, ExpectedRandomQualityParameter.ActualValue.Value,
+        EvaluatorParameter.ActualValue);
     }
 
